=== debian/changelog ===
quantlib (1.27-1) unstable; urgency=medium

  * New upstream release

 -- Dirk Eddelbuettel <edd@debian.org>  Fri, 22 Jul 2022 05:44:23 -0500

quantlib (1.26.99-1) experimental; urgency=medium

  * New upstream release candidate 1.27-rc

 -- Dirk Eddelbuettel <edd@debian.org>  Thu, 14 Jul 2022 11:18:28 -0500

quantlib (1.26-1.2110.1) impish; urgency=medium

  * PPA build for Ubuntu 21.10 ("impish")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 20 Apr 2022 08:15:50 -0500

quantlib (1.26-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 20 Apr 2022 08:12:41 -0500

quantlib (1.26-1) unstable; urgency=medium

  * New upstream release

  * debian/watch: Updated

 -- Dirk Eddelbuettel <edd@debian.org>  Wed, 20 Apr 2022 07:02:50 -0500

quantlib (1.25-1.2104.1) hirsute; urgency=medium

  * PPA build for Ubuntu 21.04 ("hirsute")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 18 Jan 2022 10:22:04 -0600

quantlib (1.25-1.2004.1) focal; urgency=medium

  * PPA build for Ubuntu 20.04 ("focal")

 -- Dirk Eddelbuettel <edd@debian.org>  Tue, 18 Jan 2022 10:21:34 -0600
